#include "board.h"
#include <cassert>
using namespace Imagine;

// Q3
void init(Board& b) {
    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            if((i+j)%2 == 0)
                b.cases[i][j]=WHITE;
            else
                b.cases[i][j]=BLACK;
}

// Q4
void drawCase(Board b, int i, int j) {
    fillRect(border+i*z+1,border+j*z+1,z-2,z-2,b.cases[i][j]);
}

void draw(Board b) {
    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            drawCase(b,i,j);
    drawRect(border,border,n*z,n*z,BLACK);
}

// Q6
bool getCase(int& x, int& y) {
    if(x>border) x = (x-border)/z; else x=-1;
    if(y>border) y = (y-border)/z; else y=-1;
    return (0<=x && x<n && 0<=y && y<n);
}

// Q7
void centerCase(int& x, int& y) {
    assert(0<=x && x<n && 0<=y && y<n);
    x = border+x*z+z/2;
    y = border+y*z+z/2;
}

// Q8
bool isfree(Board b, int i, int j) {
    return (b.cases[i][j]==BLACK || b.cases[i][j]==WHITE);
}

// Q9
int nfree(Board b) {
    int k=n*n;
    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            if(! isfree(b,i,j))
                --k;
    return k;
}

// Q10
Color colors[8] = {BLUE, CYAN, GREEN, MAGENTA, ORANGE, PURPLE, RED, YELLOW};

// Q11
void forbid(Board& b, int x, int y, int dx, int dy, Color c) {
    for(x+=dx, y+=dy; 0<=x && x<n && 0<=y && y<n; x+=dx, y+=dy)
        if(isfree(b,x,y)) {
            b.cases[x][y] = c;
            drawCase(b,x,y);
        }
}

void forbid(Board& b, int i, int j) {
    b.cases[i][j] = colors[i];
    for(int dx=-1; dx<=1; dx++)
        for(int dy=-1; dy<=1; dy++)
            if(dx!=0 || dy!=0)
                forbid(b,i,j,dx,dy, colors[i]);
}
